-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Data Editors - Editor Appearance Variants
DevExtreme Editors include the following appearance customization properties:
-
stylingMode: "filled" | "outlined" | "underlined"
Specifies the style used for text fields. -
labelMode: "static" | "floating" | "hidden" | "outside"
Specifies label display mode.
Backend API
$(() => {
const stylingMode = 'outlined';
const labelMode = 'static';
DevExpress.config({
editorStylingMode: stylingMode,
});
const name = $('#name').dxTextBox({
value: 'Olivia Peyton',
placeholder: 'Type...',
inputAttr: { 'aria-label': 'Name' },
label: 'Name',
labelMode,
}).dxValidator({
validationRules: [{
type: 'required',
}],
}).dxTextBox('instance');
const place = $('#address').dxTextBox({
placeholder: 'Type...',
inputAttr: { 'aria-label': 'Address' },
label: 'Address',
labelMode,
}).dxValidator({
validationRules: [{
type: 'required',
}],
}).dxTextBox('instance');
const birthDate = $('#birth-date').dxDateBox({
label: 'Birth Date',
placeholder: 'Select...',
value: '6/3/1981',
inputAttr: { 'aria-label': 'Birth Date' },
labelMode,
}).dxValidator({
validationRules: [{
type: 'required',
}],
}).dxDateBox('instance');
const hireDate = $('#hire-date').dxDateBox({
label: 'Hire Date',
placeholder: 'Select...',
inputAttr: { 'aria-label': 'Hire Date' },
labelMode,
}).dxValidator({
validationRules: [{
type: 'required',
}],
}).dxDateBox('instance');
const range = $('#vacation-dates').dxDateRangeBox({
startDate: '6/3/2023',
startDateLabel: 'Start Vacation Date',
endDate: '12/3/2023',
endDateLabel: 'End Vacation Date',
labelMode,
}).dxDateRangeBox('instance');
const state = $('#state').dxSelectBox({
items: states,
inputAttr: { 'aria-label': 'State' },
placeholder: 'Select...',
label: 'State',
labelMode,
validationMessagePosition: 'left',
}).dxValidator({
validationRules: [{
type: 'required',
}],
}).dxSelectBox('instance');
const phone = $('#phone').dxTextBox({
label: 'Phone',
mask: '(X00) 000-0000',
inputAttr: { 'aria-label': 'Phone' },
maskRules: {
X: /[02-9]/,
},
labelMode,
}).dxValidator({
validationRules: [{
type: 'required',
}],
}).dxTextBox('instance');
const notes = $('#notes').dxTextArea({
value: 'Olivia loves to sell. She has been selling DevAV products since 2012.',
placeholder: 'Type...',
label: 'Notes',
labelMode,
inputAttr: { 'aria-label': 'Notes' },
}).dxTextArea('instance');
$('#validate').dxButton({
text: 'Save',
icon: 'save',
type: 'default',
onClick({ validationGroup }) {
const result = validationGroup.validate();
if (result.isValid) {
DevExpress.ui.notify('The task was saved successfully.', 'success');
} else {
DevExpress.ui.notify('The task was not saved. Please check if all fields are valid.', 'error');
}
},
});
const getValueChangedHandler = (optionName) => ({ value }) => {
[name, place, birthDate, hireDate, range, state, phone, notes].forEach((editor) => {
editor.option(optionName, value);
});
};
$('#styling-mode-selector').dxSelectBox({
items: ['outlined', 'filled', 'underlined'],
value: 'outlined',
label: 'Styling Mode',
labelMode: 'outside',
inputAttr: { 'aria-label': 'Styling Mode' },
onValueChanged: getValueChangedHandler('stylingMode'),
}).dxSelectBox('instance');
$('#label-mode-selector').dxSelectBox({
items: ['static', 'floating', 'hidden', 'outside'],
value: 'static',
label: 'Label Mode',
labelMode: 'outside',
inputAttr: { 'aria-label': 'Label Mode' },
onValueChanged: getValueChangedHandler('labelMode'),
}).dxSelectBox('instance');
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
<script src="data.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="options">
<div class="caption">Options</div>
<div class="editors-modes">
<div class="option">
<div id="styling-mode-selector"></div>
</div>
<div class="option">
<div id="label-mode-selector"></div>
</div>
</div>
</div>
<div class="widgets-container">
<div class="title">Edit Profile</div>
<div id="name"></div>
<div id="address"></div>
<div id="birth-date"></div>
<div id="state"></div>
<div id="phone"></div>
<div id="hire-date"></div>
<div id="vacation-dates"></div>
<div id="notes"></div>
</div>
<div id="validate"></div>
</div>
</body>
</html>
.demo-container {
height: 680px;
}
.widgets-container {
display: grid;
grid-template-areas:
'title title title title'
'name name birthDate birthDate '
'address address state phone'
'hireDate hireDate range range'
'notes notes notes notes';
grid-template-columns: 1fr 1fr 1fr 1fr;
gap: 20px;
padding-left: 20px;
padding-right: 20px;
}
.title {
grid-area: title;
font-size: 18px;
font-weight: 500;
}
#name {
grid-area: name;
}
#address {
grid-area: address;
}
#birth-date {
grid-area: birthDate;
}
#state {
grid-area: state;
}
#phone {
grid-area: phone;
}
#hire-date {
grid-area: hireDate;
}
#notes {
grid-area: notes;
}
#vacation-dates {
grid-area: range;
}
#validate {
float: right;
margin-top: 20px;
margin-right: 20px;
width: 100px;
}
.options {
grid-area: options;
padding: 20px;
margin-bottom: 40px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.editors-modes {
display: flex;
}
.option {
padding-right: 20px;
margin-top: 20px;
}
const states = ['AL', 'AK', 'AZ', 'AR', 'CA', 'CO', 'CT', 'DE', 'FL', 'GA', 'HI', 'ID', 'IL', 'IN', 'IA', 'KS', 'KY', 'LA', 'ME', 'MD', 'MA', 'MI', 'MN', 'MS', 'MO', 'MT', 'NE', 'NV', 'NH', 'NJ', 'NM', 'NY', 'NC', 'ND', 'OH', 'OK', 'OR', 'PA', 'RI', 'SC', 'SD', 'TN', 'TX', 'UT', 'VT', 'VA', 'WA', 'WV', 'WI', 'WY'];
To specify styles globally (as an alternative to stylingMode), set the editorStylingMode property instead (editorStylingMode applies the same style to all editors on the page).
In this demo, you can use the "Styling Mode/Label Mode" drop down box (in the Options section) to modify styling and label modes.

Backend API
<template>
<div id="content-wrapper">
<div class="options">
<div class="caption">Options</div>
<div className="editors-modes">
<div class="option">
<DxSelectBox
:input-attr="{ 'aria-label': 'Styling Mode' }"
:items="[ 'outlined', 'filled', 'underlined' ]"
styling-mode="outlined"
label="Styling Mode"
label-mode="outside"
v-model:value="stylingMode"
/>
</div>
<div class="option">
<DxSelectBox
:input-attr="{ 'aria-label': 'Label Mode' }"
:items="[ 'static', 'floating', 'hidden', 'outside' ]"
styling-mode="outlined"
label="Label Mode"
label-mode="outside"
v-model:value="labelMode"
/>
</div>
</div>
</div>
<div className="widgets-container">
<div class="title">Edit Profile</div>
<DxTextBox
:styling-mode="stylingMode"
:label-mode="labelMode"
:input-attr="{ 'aria-label': 'Name' }"
value="Olivia Peyton"
id="name"
placeholder="Type..."
label="Name"
>
<DxValidator>
<DxRequiredRule/>
</DxValidator>
</DxTextBox>
<DxTextBox
:styling-mode="stylingMode"
:label-mode="labelMode"
:input-attr="{ 'aria-label': 'Address' }"
placeholder="Type..."
label="Address"
id="address"
>
<DxValidator>
<DxRequiredRule/>
</DxValidator>
</DxTextBox>
<DxDateBox
:styling-mode="stylingMode"
:label-mode="labelMode"
:input-attr="{ 'aria-label': 'Hire Date' }"
id="hire-date"
placeholder="Select..."
label="Hire Date"
>
<DxValidator>
<DxRequiredRule/>
</DxValidator>
</DxDateBox>
<DxDateBox
:styling-mode="stylingMode"
:label-mode="labelMode"
:input-attr="{ 'aria-label': 'Birth Date' }"
:value="birthDate"
id="birth-date"
placeholder="Select..."
label="Birth Date"
>
<DxValidator>
<DxRequiredRule/>
</DxValidator>
</DxDateBox>
<DxSelectBox
:items="states"
:input-attr="{ 'aria-label': 'State' }"
:styling-mode="stylingMode"
:label-mode="labelMode"
id="state"
placeholder="Select..."
label="State"
validation-message-position="left"
>
<DxValidator>
<DxRequiredRule/>
</DxValidator>
</DxSelectBox>
<DxTextBox
:styling-mode="stylingMode"
:label-mode="labelMode"
:mask-rules="phoneRules"
:input-attr="{ 'aria-label': 'Phone' }"
id="phone"
mask="(X00) 000-0000"
label="Phone"
>
<DxValidator>
<DxRequiredRule/>
</DxValidator>
</DxTextBox>
<DxDateRangeBox
:styling-mode="stylingMode"
:label-mode="labelMode"
id="vacation-dates"
start-date="6/3/2023"
start-date-label="Start Vacation Date"
end-date="12/3/2023"
end-date-label="End Vacation Date"
/>
<DxTextArea
:styling-mode="stylingMode"
:label-mode="labelMode"
:value="text"
:input-attr="{ 'aria-label': 'Notes' }"
id="notes"
placeholder="Type..."
label="Notes"
/>
</div>
<DxButton
@click="validateClick"
text="Save"
icon="save"
type="default"
id="validate"
class="validate"
/>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import type { EditorStyle, LabelMode } from 'devextreme-vue/common';
import DxSelectBox from 'devextreme-vue/select-box';
import DxTextBox from 'devextreme-vue/text-box';
import DxTextArea from 'devextreme-vue/text-area';
import DxDateBox from 'devextreme-vue/date-box';
import DxButton, { type DxButtonTypes } from 'devextreme-vue/button';
import DxDateRangeBox from 'devextreme-vue/date-range-box';
import {
DxValidator,
DxRequiredRule,
} from 'devextreme-vue/validator';
import notify from 'devextreme/ui/notify';
import { states } from './data.ts';
const birthDate = ref(new Date(1981, 5, 3));
const stylingMode = ref<EditorStyle>('outlined');
const labelMode = ref<LabelMode>('static');
const text = ref('Olivia loves to sell. She has been selling DevAV products since 2012.');
const phoneRules = {
X: /[02-9]/,
};
function validateClick({ validationGroup }: DxButtonTypes.ClickEvent) {
const result = validationGroup.validate();
if (result.isValid) {
notify('The task was saved successfully.', 'success');
} else {
notify('The task was not saved. Please check if all fields are valid.', 'error');
}
}
</script>
<style>
#content-wrapper {
height: 680px;
}
.widgets-container {
display: grid;
grid-template-areas:
'title title title title'
'name name birthDate birthDate '
'address address state phone'
'hireDate hireDate range range'
'notes notes notes notes';
grid-template-columns: 1fr 1fr 1fr 1fr;
gap: 20px;
padding-left: 20px;
padding-right: 20px;
}
.title {
grid-area: title;
font-size: 18px;
font-weight: 500;
}
#name {
grid-area: name;
}
#address {
grid-area: address;
}
#birth-date {
grid-area: birthDate;
}
#state {
grid-area: state;
}
#phone {
grid-area: phone;
}
#hire-date {
grid-area: hireDate;
}
#notes {
grid-area: notes;
}
#vacation-dates {
grid-area: range;
}
#validate {
float: right;
margin-top: 20px;
margin-right: 20px;
width: 100px;
}
.options {
grid-area: options;
padding: 20px;
margin-bottom: 40px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.editors-modes {
display: flex;
}
.option {
padding-right: 20px;
margin-top: 20px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const states = ['AL', 'AK', 'AZ', 'AR', 'CA', 'CO', 'CT', 'DE', 'FL', 'GA', 'HI', 'ID', 'IL', 'IN', 'IA', 'KS', 'KY', 'LA', 'ME', 'MD', 'MA', 'MI', 'MN', 'MS', 'MO', 'MT', 'NE', 'NV', 'NH', 'NJ', 'NM', 'NY', 'NC', 'ND', 'OH', 'OK', 'OR', 'PA', 'RI', 'SC', 'SD', 'TN', 'TX', 'UT', 'VT', 'VA', 'WA', 'WV', 'WI', 'WY'];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
To specify styles globally (as an alternative to stylingMode), set the editorStylingMode property instead (editorStylingMode applies the same style to all editors on the page).
In this demo, you can use the "Styling Mode/Label Mode" drop down box (in the Options section) to modify styling and label modes.

Backend API
<div id="content-wrapper">
<div class="options">
<div class="caption">Options</div>
<div class="editors-modes">
<div class="option">
<dx-select-box
[items]="['outlined', 'filled', 'underlined']"
[inputAttr]="{ 'aria-label': 'Styling Mode' }"
stylingMode="outlined"
label="Styling Mode"
labelMode="outside"
[(value)]="stylingMode"
></dx-select-box>
</div>
<div class="option">
<dx-select-box
[items]="['floating', 'static', 'hidden', 'outside']"
[inputAttr]="{ 'aria-label': 'Label Mode' }"
stylingMode="outlined"
label="Label Mode"
labelMode="outside"
[(value)]="labelMode"
></dx-select-box>
</div>
</div>
</div>
<div class="widgets-container">
<div class="title">Edit Profile</div>
<dx-text-box
value="Olivia Peyton"
[inputAttr]="{ 'aria-label': 'Name' }"
label="Name"
id="name"
placeholder="Type..."
[stylingMode]="stylingMode"
[labelMode]="labelMode"
>
<dx-validator>
<dxi-validator-validation-rule type="required">
</dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
<dx-text-box
label="Address"
[inputAttr]="{ 'aria-label': 'Address' }"
placeholder="Type..."
id="address"
[stylingMode]="stylingMode"
[labelMode]="labelMode"
>
<dx-validator>
<dxi-validator-validation-rule type="required">
</dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
<dx-date-box
label="Hire Date"
id="hire-date"
placeholder="Select..."
[stylingMode]="stylingMode"
[labelMode]="labelMode"
[inputAttr]="{ 'aria-label': 'Hire Date' }"
>
<dx-validator>
<dxi-validator-validation-rule type="required">
</dxi-validator-validation-rule>
</dx-validator>
</dx-date-box>
<dx-date-box
[value]="birthDate"
label="Birth Date"
id="birth-date"
placeholder="Select..."
[stylingMode]="stylingMode"
[labelMode]="labelMode"
[inputAttr]="{ 'aria-label': 'Birth Date' }"
>
<dx-validator>
<dxi-validator-validation-rule type="required">
</dxi-validator-validation-rule>
</dx-validator>
</dx-date-box>
<dx-select-box
[items]="states"
placeholder="Select..."
[inputAttr]="{ 'aria-label': 'State' }"
label="State"
id="state"
[stylingMode]="stylingMode"
[labelMode]="labelMode"
validationMessagePosition="left"
>
<dx-validator>
<dxi-validator-validation-rule type="required">
</dxi-validator-validation-rule>
</dx-validator>
</dx-select-box>
<dx-text-box
label="Phone"
[inputAttr]="{ 'aria-label': 'Phone' }"
mask="(X00) 000-0000"
id="phone"
[maskRules]="phoneRules"
[stylingMode]="stylingMode"
[labelMode]="labelMode"
>
<dx-validator>
<dxi-validator-validation-rule type="required">
</dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
<dx-date-range-box
[stylingMode]="stylingMode"
[labelMode]="labelMode"
id="vacation-dates"
startDate="6/3/2023"
startDateLabel="Start Vacation Date"
endDate="12/3/2023"
endDateLabel="End Vacation Date"
></dx-date-range-box>
<dx-text-area
value="Olivia loves to sell. She has been selling DevAV products since 2012."
placeholder="Type..."
label="Notes"
id="notes"
[stylingMode]="stylingMode"
[labelMode]="labelMode"
[inputAttr]="{ 'aria-label': 'Notes' }"
></dx-text-area>
</div>
<dx-button
text="Save"
type="default"
icon="save"
id="validate"
(onClick)="validateClick($event)"
class="validate"
></dx-button>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxSelectBoxModule,
DxTextAreaModule,
DxTagBoxModule,
DxDateBoxModule,
DxButtonModule,
DxValidatorModule,
DxDateRangeBoxModule,
DxTextBoxModule,
} from 'devextreme-angular';
import notify from 'devextreme/ui/notify';
import { EditorStyle, LabelMode } from 'devextreme-angular/common';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
imports: [
DxSelectBoxModule,
DxTextBoxModule,
DxTextAreaModule,
DxTagBoxModule,
DxDateBoxModule,
DxButtonModule,
DxValidatorModule,
DxDateRangeBoxModule,
],
})
export class AppComponent {
stylingMode: EditorStyle = 'outlined';
labelMode: LabelMode = 'static';
birthDate = new Date(1981, 5, 3);
states: string[];
phoneRules = {
X: /[02-9]/,
};
validateClick({ validationGroup }) {
const result = validationGroup.validate();
if (result.isValid) {
notify('The task was saved successfully.', 'success');
} else {
notify('The task was not saved. Please check if all fields are valid.', 'error');
}
}
constructor(service: Service) {
this.states = service.getStates();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #content-wrapper {
height: 680px;
}
::ng-deep .widgets-container {
display: grid;
grid-template-areas:
'title title title title'
'name name birthDate birthDate '
'address address state phone'
'hireDate hireDate range range'
'notes notes notes notes';
grid-template-columns: 1fr 1fr 1fr 1fr;
gap: 20px;
padding-left: 20px;
padding-right: 20px;
}
::ng-deep .title {
grid-area: title;
font-size: 18px;
font-weight: 500;
}
::ng-deep #name {
grid-area: name;
}
::ng-deep #address {
grid-area: address;
}
::ng-deep #birth-date {
grid-area: birthDate;
}
::ng-deep #state {
grid-area: state;
}
::ng-deep #phone {
grid-area: phone;
}
::ng-deep #hire-date {
grid-area: hireDate;
}
::ng-deep #notes {
grid-area: notes;
}
::ng-deep #vacation-dates {
grid-area: range;
}
::ng-deep #validate {
float: right;
margin-top: 20px;
margin-right: 20px;
width: 100px;
}
.options {
grid-area: options;
padding: 20px;
margin-bottom: 40px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep .editors-modes {
display: flex;
}
.option {
padding-right: 20px;
margin-top: 20px;
}
import { Injectable } from '@angular/core';
const states: string[] = ['AL', 'AK', 'AZ', 'AR', 'CA', 'CO', 'CT', 'DE', 'FL', 'GA', 'HI', 'ID', 'IL', 'IN', 'IA', 'KS', 'KY', 'LA', 'ME', 'MD', 'MA', 'MI', 'MN', 'MS', 'MO', 'MT', 'NE', 'NV', 'NH', 'NJ', 'NM', 'NY', 'NC', 'ND', 'OH', 'OK', 'OR', 'PA', 'RI', 'SC', 'SD', 'TN', 'TX', 'UT', 'VT', 'VA', 'WA', 'WV', 'WI', 'WY'];
@Injectable()
export class Service {
getStates() {
return states;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
To specify styles globally (as an alternative to stylingMode), set the editorStylingMode property instead (editorStylingMode applies the same style to all editors on the page).
In this demo, you can use the "Styling Mode/Label Mode" drop down box (in the Options section) to modify styling and label modes.

Backend API
import React, { useCallback, useState } from 'react';
import type { EditorStyle, LabelMode } from 'devextreme-react/common';
import notify from 'devextreme/ui/notify';
import { SelectBox } from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import { TextBox } from 'devextreme-react/text-box';
import { DateBox } from 'devextreme-react/date-box';
import { DateRangeBox } from 'devextreme-react/date-range-box';
import { TextArea } from 'devextreme-react/text-area';
import { Button } from 'devextreme-react/button';
import type { ButtonTypes } from 'devextreme-react/button';
import { Validator, RequiredRule } from 'devextreme-react/validator';
import {
states,
stylingModes,
labelModes,
notesLabel,
birthDateLabel,
hireDateLabel,
nameLabel,
addressLabel,
phoneLabel,
stateLabel,
labelModeLabel,
stylingModeLabel,
} from './data.ts';
const phoneRules = {
X: /[02-9]/,
};
function validateClick({ validationGroup }: ButtonTypes.ClickEvent): void {
const result = validationGroup.validate();
if (result.isValid) {
notify('The task was saved successfully.', 'success');
} else {
notify('The task was not saved. Please check if all fields are valid.', 'error');
}
}
export default function App() {
const defaultStylingMode = 'outlined';
const [stylingMode, setStylingMode] = useState<EditorStyle>(defaultStylingMode);
const [labelMode, setLabelMode] = useState<LabelMode>('static');
const changeStylingMode = useCallback(
({ value }: SelectBoxTypes.ValueChangedEvent): void => {
setStylingMode(value);
},
[],
);
const labelModeChange = useCallback(
({ value }: SelectBoxTypes.ValueChangedEvent): void => {
setLabelMode(value);
},
[],
);
return (
<>
<div className="options">
<div className="caption">Options</div>
<div className="editors-modes">
<div className="option">
<SelectBox
label="Styling Mode"
labelMode="outside"
stylingMode={defaultStylingMode}
items={stylingModes}
inputAttr={stylingModeLabel}
value={stylingMode}
onValueChanged={changeStylingMode}
/>
</div>
<div className="option">
<SelectBox
label="Label Mode"
labelMode="outside"
stylingMode={defaultStylingMode}
items={labelModes}
inputAttr={labelModeLabel}
value={labelMode}
onValueChanged={labelModeChange}
/>
</div>
</div>
</div>
<div className="widgets-container">
<div className="title">Edit Profile</div>
<TextBox
id="name"
stylingMode={stylingMode}
defaultValue="Olivia Peyton"
inputAttr={nameLabel}
placeholder="Type..."
label="Name"
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</TextBox>
<TextBox
id="address"
stylingMode={stylingMode}
placeholder="Type..."
inputAttr={addressLabel}
label="Address"
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</TextBox>
<DateBox
id="hire-date"
stylingMode={stylingMode}
placeholder="Select..."
label="Hire Date"
inputAttr={hireDateLabel}
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</DateBox>
<DateBox
id="birth-date"
defaultValue="6/3/1981"
stylingMode={stylingMode}
placeholder="Birth Date"
label="Birth Date"
inputAttr={birthDateLabel}
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</DateBox>
<SelectBox
id="state"
items={states}
stylingMode={stylingMode}
inputAttr={stateLabel}
placeholder="Select..."
label="State"
labelMode={labelMode}
validationMessagePosition="left"
>
<Validator>
<RequiredRule />
</Validator>
</SelectBox>
<TextBox
id="phone"
stylingMode={stylingMode}
mask="(X00) 000-0000"
inputAttr={phoneLabel}
maskRules={phoneRules}
label="Phone"
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</TextBox>
<DateRangeBox
id="vacation-dates"
startDate="6/3/2023"
startDateLabel="Start Vacation Date"
endDate="12/3/2023"
endDateLabel="End Vacation Date"
stylingMode={stylingMode}
labelMode={labelMode}
/>
<TextArea
id="notes"
stylingMode={stylingMode}
defaultValue="Olivia loves to sell. She has been selling DevAV products since 2012."
placeholder="Type..."
label="Notes"
labelMode={labelMode}
inputAttr={notesLabel}
/>
</div>
<Button
onClick={validateClick}
text="Save"
icon="save"
type="default"
id="validate"
/>
</>
);
}
import React, { useCallback, useState } from 'react';
import notify from 'devextreme/ui/notify';
import { SelectBox } from 'devextreme-react/select-box';
import { TextBox } from 'devextreme-react/text-box';
import { DateBox } from 'devextreme-react/date-box';
import { DateRangeBox } from 'devextreme-react/date-range-box';
import { TextArea } from 'devextreme-react/text-area';
import { Button } from 'devextreme-react/button';
import { Validator, RequiredRule } from 'devextreme-react/validator';
import {
states,
stylingModes,
labelModes,
notesLabel,
birthDateLabel,
hireDateLabel,
nameLabel,
addressLabel,
phoneLabel,
stateLabel,
labelModeLabel,
stylingModeLabel,
} from './data.js';
const phoneRules = {
X: /[02-9]/,
};
function validateClick({ validationGroup }) {
const result = validationGroup.validate();
if (result.isValid) {
notify('The task was saved successfully.', 'success');
} else {
notify('The task was not saved. Please check if all fields are valid.', 'error');
}
}
export default function App() {
const defaultStylingMode = 'outlined';
const [stylingMode, setStylingMode] = useState(defaultStylingMode);
const [labelMode, setLabelMode] = useState('static');
const changeStylingMode = useCallback(({ value }) => {
setStylingMode(value);
}, []);
const labelModeChange = useCallback(({ value }) => {
setLabelMode(value);
}, []);
return (
<>
<div className="options">
<div className="caption">Options</div>
<div className="editors-modes">
<div className="option">
<SelectBox
label="Styling Mode"
labelMode="outside"
stylingMode={defaultStylingMode}
items={stylingModes}
inputAttr={stylingModeLabel}
value={stylingMode}
onValueChanged={changeStylingMode}
/>
</div>
<div className="option">
<SelectBox
label="Label Mode"
labelMode="outside"
stylingMode={defaultStylingMode}
items={labelModes}
inputAttr={labelModeLabel}
value={labelMode}
onValueChanged={labelModeChange}
/>
</div>
</div>
</div>
<div className="widgets-container">
<div className="title">Edit Profile</div>
<TextBox
id="name"
stylingMode={stylingMode}
defaultValue="Olivia Peyton"
inputAttr={nameLabel}
placeholder="Type..."
label="Name"
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</TextBox>
<TextBox
id="address"
stylingMode={stylingMode}
placeholder="Type..."
inputAttr={addressLabel}
label="Address"
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</TextBox>
<DateBox
id="hire-date"
stylingMode={stylingMode}
placeholder="Select..."
label="Hire Date"
inputAttr={hireDateLabel}
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</DateBox>
<DateBox
id="birth-date"
defaultValue="6/3/1981"
stylingMode={stylingMode}
placeholder="Birth Date"
label="Birth Date"
inputAttr={birthDateLabel}
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</DateBox>
<SelectBox
id="state"
items={states}
stylingMode={stylingMode}
inputAttr={stateLabel}
placeholder="Select..."
label="State"
labelMode={labelMode}
validationMessagePosition="left"
>
<Validator>
<RequiredRule />
</Validator>
</SelectBox>
<TextBox
id="phone"
stylingMode={stylingMode}
mask="(X00) 000-0000"
inputAttr={phoneLabel}
maskRules={phoneRules}
label="Phone"
labelMode={labelMode}
>
<Validator>
<RequiredRule />
</Validator>
</TextBox>
<DateRangeBox
id="vacation-dates"
startDate="6/3/2023"
startDateLabel="Start Vacation Date"
endDate="12/3/2023"
endDateLabel="End Vacation Date"
stylingMode={stylingMode}
labelMode={labelMode}
/>
<TextArea
id="notes"
stylingMode={stylingMode}
defaultValue="Olivia loves to sell. She has been selling DevAV products since 2012."
placeholder="Type..."
label="Notes"
labelMode={labelMode}
inputAttr={notesLabel}
/>
</div>
<Button
onClick={validateClick}
text="Save"
icon="save"
type="default"
id="validate"
/>
</>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
import type { EditorStyle, LabelMode } from 'devextreme-react/common';
export const states: string[] = ['AL', 'AK', 'AZ', 'AR', 'CA', 'CO', 'CT', 'DE', 'FL', 'GA', 'HI', 'ID', 'IL', 'IN', 'IA', 'KS', 'KY', 'LA', 'ME', 'MD', 'MA', 'MI', 'MN', 'MS', 'MO', 'MT', 'NE', 'NV', 'NH', 'NJ', 'NM', 'NY', 'NC', 'ND', 'OH', 'OK', 'OR', 'PA', 'RI', 'SC', 'SD', 'TN', 'TX', 'UT', 'VT', 'VA', 'WA', 'WV', 'WI', 'WY'];
export const stylingModes: EditorStyle[] = ['outlined', 'filled', 'underlined'];
export const labelModes: LabelMode[] = ['static', 'floating', 'hidden', 'outside'];
export const notesLabel = { 'aria-label': 'Notes' };
export const birthDateLabel = { 'aria-label': 'Birth Date' };
export const hireDateLabel = { 'aria-label': 'Hire Date' };
export const nameLabel = { 'aria-label': 'Name' };
export const addressLabel = { 'aria-label': 'Address' };
export const phoneLabel = { 'aria-label': 'Phone' };
export const stateLabel = { 'aria-label': 'State' };
export const labelModeLabel = { 'aria-label': 'Label Mode' };
export const stylingModeLabel = { 'aria-label': 'Styling Mode' };
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const states = [
'AL',
'AK',
'AZ',
'AR',
'CA',
'CO',
'CT',
'DE',
'FL',
'GA',
'HI',
'ID',
'IL',
'IN',
'IA',
'KS',
'KY',
'LA',
'ME',
'MD',
'MA',
'MI',
'MN',
'MS',
'MO',
'MT',
'NE',
'NV',
'NH',
'NJ',
'NM',
'NY',
'NC',
'ND',
'OH',
'OK',
'OR',
'PA',
'RI',
'SC',
'SD',
'TN',
'TX',
'UT',
'VT',
'VA',
'WA',
'WV',
'WI',
'WY',
];
export const stylingModes = ['outlined', 'filled', 'underlined'];
export const labelModes = ['static', 'floating', 'hidden', 'outside'];
export const notesLabel = { 'aria-label': 'Notes' };
export const birthDateLabel = { 'aria-label': 'Birth Date' };
export const hireDateLabel = { 'aria-label': 'Hire Date' };
export const nameLabel = { 'aria-label': 'Name' };
export const addressLabel = { 'aria-label': 'Address' };
export const phoneLabel = { 'aria-label': 'Phone' };
export const stateLabel = { 'aria-label': 'State' };
export const labelModeLabel = { 'aria-label': 'Label Mode' };
export const stylingModeLabel = { 'aria-label': 'Styling Mode' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#app {
height: 680px;
}
.widgets-container {
display: grid;
grid-template-areas:
'title title title title'
'name name birthDate birthDate '
'address address state phone'
'hireDate hireDate range range'
'notes notes notes notes';
grid-template-columns: 1fr 1fr 1fr 1fr;
gap: 20px;
padding-left: 20px;
padding-right: 20px;
}
.title {
grid-area: title;
font-size: 18px;
font-weight: 500;
}
#name {
grid-area: name;
}
#address {
grid-area: address;
}
#birth-date {
grid-area: birthDate;
}
#state {
grid-area: state;
}
#phone {
grid-area: phone;
}
#hire-date {
grid-area: hireDate;
}
#notes {
grid-area: notes;
}
#vacation-dates {
grid-area: range;
}
#validate {
float: right;
margin-top: 20px;
margin-right: 20px;
width: 100px;
}
.options {
grid-area: options;
padding: 20px;
margin-bottom: 40px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.editors-modes {
display: flex;
}
.option {
padding-right: 20px;
margin-top: 20px;
}
To specify styles globally (as an alternative to stylingMode), set the editorStylingMode property instead (editorStylingMode applies the same style to all editors on the page).
In this demo, you can use the "Styling Mode/Label Mode" drop down box (in the Options section) to modify styling and label modes.